package com.gxzc.zen.web.sys.controller

import com.gxzc.zen.api.sys.service.ISysUploadInfoService
import com.gxzc.zen.common.base.BaseController
import com.gxzc.zen.msg.mq.MQProducerUtil
import com.maihaoche.starter.mq.base.MessageBuilder
import org.apache.shiro.SecurityUtils
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController


/**
 *
 * @author NorthLan
 * @date 2018/3/15
 * @url https://noahlan.com
 */
@RestController
@RequestMapping("test")
class TestController : BaseController() {

    @Autowired
    private lateinit var sysUploadInfoService: ISysUploadInfoService

    //    @Autowired
    //    private lateinit var mqProducer: ZenMQProducer

    @GetMapping("a")
    fun get(): ResponseEntity<*> {
        return ResponseEntity.ok(2)
    }


    @GetMapping("b")
    fun getb(): ResponseEntity<*> {
        return ResponseEntity.ok(sysUploadInfoService.selectList(null))
    }

    @GetMapping("thread")
    fun niubi(): ResponseEntity<*> {
        val subject = SecurityUtils.getSubject()
        println(subject.principal)
        val runnable = Thread(Runnable {
            kotlin.run {
                Thread.sleep(2000)
                val sub = SecurityUtils.getSubject()
                println(sub.principal)
            }
        })
        //        subject.execute {
        runnable.start()
        //        }
        return ResponseEntity.ok("2333")
    }

    @GetMapping("mq")
    fun mq(): ResponseEntity<*> {
        MQProducerUtil.producer?.syncSend(MessageBuilder.of("2333").build())
        return ResponseEntity.ok(1234)
    }

    @GetMapping("file")
    fun md5(): ResponseEntity<*> {
        //        println(FileUtil.md5HeadTail("/newfile/4/WS·1983/综合/永久/4·WS-1983-综合-0001.pdf", null))
        //        println(FileUtil.md5HeadTail("D:/data/4·WS-1983-综合-0001.pdf", null))

        //
        //        FileUtils.copyFile(File("D:/data/123.pdf"),File("D:/321.pdf"))
        //
        //        println(FileUtil.md5HeadTail("D:/data/123.pdf", 10485760))
        //        println(FileUtil.md5HeadTail("D:/321.pdf", 10485760))

        //        println(FileUtil.md5HeadTail("D:/123.pdf", null))
        //        println(FileUtil.md5HeadTail("D:/data/", null))
        return ResponseEntity.ok(2333)
    }
}